#define LEDCR IO.PCR8
#define LED IO.PDR8.BYTE
#define SWCR IO.PCR1
#define SW IO.PDR1.BYTE
#define SPCR IO.PCR7
#define SP IO.PDR7.BIT.B6

#include <3694.h>

void io_Init();
void timerv_init();
void menu_main();
void wait(unsigned long); 

void all_emit();
void all_flash();
void up_count();
void down_count();
void music0();
void music1();
void soundTest();

void oto(char m,int x);
long z=300000; //ƂȂS̒() 

int main(){
 	io_Init(); 
	while(1){
  		menu_main();
	}
	return 0;
}

void wait(unsigned long n){
  while(n--);
}

void io_Init(){
  LEDCR=0xff; //LED
  SWCR=0x00; //Switch
  SPCR=0x40; //Speaker
}

void menu_main(){
  unsigned int m=1;
  while(SW&0x40){
    LED=~m;
    if(!(SW&0x10)){
      if(m<6){
        m++;
        wait(100000);
      }
    }
    if(!(SW&0x20)){
      if(m>1){
        m--;
        wait(100000);
      }
    }
  }
  while(!(SW&0x40)){}
  wait(30000);

  
  switch(m){
    case 1: all_emit();
    case 2: all_flash();
    case 3: up_count();
    case 4: down_count();
    case 5: music0();
    case 6: music1();
    default:  soundTest();
  }
  wait(60000);
} 

void all_emit(){
  while(SW&0x40){
    LED=0x00;
  }
}
void all_flash(){
  while(SW&0x40){
    LED=0x00;
    wait(40000);
    LED=0xff;
    wait(40000);
  }
}
void up_count(){
  unsigned int n=0;
  while(n<0xff){
    LED=~n;
    wait(40000);
    n++;
  }
}
void down_count(){
  unsigned int n=0xff;
  while(n>0){
    LED=~n;
    wait(40000);
    n--;
  }
}

void timerv_init(){
  TV.TCRV0.BYTE|=0x08;  //RyA}b`AŃJE^NA
  TV.TCSRV.BYTE|=0x13;  //gOo
}

void music0(){
  timerv_init();
  while(1){ //̓𖳌ɌJԂ 
    /*---------------------- 
    oto('̍',̒) 
    ̍ KNI[e[V(')ň͂ނƁI 
    c=h,d=,e=~,f=t@,g=\,a=,b=V,j=h(IN^[u) 
    ̒ 
    SɁB 
    Ax'k' 
    --------------------------*/ 
    //ȉAy(ǂǂ񂢂Ď̋ȂtĂ) 
    //tic=0; 
    int g[44][2]={ //ŁASŉLqƂȂƃ_݂ 
      {'c',8},{'d',8},{'e',8},{'f',8}, 
      {'e',8},{'d',8},{'c',8},{'k',8}, 
      {'e',8},{'f',8},{'g',8},{'a',8}, 
      {'g',8},{'f',8},{'e',8},{'k',8}, 
      {'c',8},       {'k',8},
      {'c',8},       {'k',8},
      {'c',8},       {'k',8}, 
      {'c',8},       {'k',8}, 
      {'c',16},      {'k',32}, 
      {'c',16},      {'k',32}, 
      {'d',16},      {'k',32}, 
      {'d',16},      {'k',32}, 
      {'e',16},      {'k',32}, 
      {'e',16},      {'k',32}, 
      {'f',16},      {'k',32}, 
      {'f',16},      {'k',32}, 
      {'e',4},{'d',4},{'c',4},{'k',8} 
    };  

    int o; 
    for(o=0;o<44;o++){ 
      oto(g[o][0],g[o][1]);
    }
    DI; //荞ݏI 
  }
} 

void music1(){
  timerv_init();
  while(1){ //̓𖳌ɌJԂ 
    int g[78][2]={ //ŁASŉLqƂȂƃ_݂ 
      {'f',8},{'k',16},{'f',16},{'k',32},{'f',8},{'k',16},
     {'f',16},{'k',32},{'f',8},{'k',16},{'f',16},{'k',32},
     {'f',8},{'k',16},{'f',16},{'k',32}, //16
     {'g',8},{'k',16},{'f',16},{'k',32},{'e',8},{'k',16},
     {'d',16},{'k',32},{'c',4},{'k',4}, //10
     {'f',8},{'k',16},{'f',16},{'k',32},{'f',4},{'k',16}, //6
     {'f',8},{'k',16},{'f',16},{'k',32},{'f',4},{'k',16}, //6
     {'a',8},{'k',16},{'f',16},{'k',32},{'g',8},{'k',16},
     {'e',16},{'k',32}, {'f',4},{'k',16}, //10
     {'f',8},{'k',16},{'f',16},{'k',32}, {'d',2},{'k',16}, //6
     {'f',8},{'k',16},{'f',16},{'k',32}, {'c',2},{'k',8}, //6
     {'c',8},{'k',16},{'d',16},{'k',32},{'d',8},{'k',16},
     {'d',16},{'k',32}, {'d',8},{'k',16},{'d',16},{'k',16},
     {'e',8},{'k',16},{'f',16},{'k',32},{'g',2},{'k',1}, //18
    }; 
   
    int o; 
    for(o=0;o<78;o++){ 
      oto(g[o][0],g[o][1]);
    }
    DI; //荞ݏI 
  }
}

void oto(char m,int x){ //֐(̍,̒) 
  switch(m){ 
    case 'c': TV.TCORA=149; LED=~0x01;break; 
    case 'd': TV.TCORA=133; LED=~0x02;break; 
    case 'e': TV.TCORA=119; LED=~0x04;break; 
    case 'f': TV.TCORA=112; LED=~0x08;break; 
    case 'g': TV.TCORA=100; LED=~0x10;break; 
    case 'a': TV.TCORA=89; LED=~0x20;break; 
    case 'b': TV.TCORA=79; LED=~0x40;break; 
    case 'j': TV.TCORA=75; LED=~0x80;break; 
    case 'k': LED=~0x00;break; 
  }
  if(m!='k'){ //xȊȌ 
    EI; //荞݋
    TV.TCRV0.BYTE|=0x03;  //JE^X^[g/64
  } 
  unsigned long temp;
  temp=z*4/x; //特̒߂ 
  while(temp>0)temp--; //waitB̒߂Ă 
  TV.TCRV0.BYTE&=~0x03; //JE^Xgbv
  DI; //荞ݏI 
} 

void soundTest(){
  while(1){
    SP=1;
    wait(200);
    SP=0;
    wait(200);
  }
} 
